extern crate core;

mod client;
mod config;
mod handles;
mod typing;
mod utils;
mod events;

use crate::events::handle_events;
use client::handle_client;
use config::config::STATIC_ADDR as addr;
use tokio::net::TcpListener;
use tokio::sync::mpsc;

#[tokio::main]
async fn main() {
    let listener = TcpListener::bind(addr).await.unwrap();
    // 创建事件通道
    let (event_sender, event_receiver) = mpsc::unbounded_channel();
    // 启动事件处理任务
    tokio::spawn(handle_events(event_receiver));
    while let Ok((stream, _)) = listener.accept().await {
        tokio::spawn(handle_client(stream, event_sender.clone()));
    }
}