use std::collections::HashMap;

pub(crate) fn get_connection_params(
    connection_url: String,
) -> Result<HashMap<String, String>, &'static str> {
    if let Some(query_part) = connection_url.split('?').nth(1) {
        let mut params_mapping = HashMap::new();
        for param in query_part.split('&') {
            if let Some((key, value)) = param.split_once('=') {
                params_mapping.insert(key.to_string(), value.to_string());
            } else {
                return Err("Invalid parameter format, missing '='");
            }
        }
        Ok(params_mapping)
    } else {
        Ok(HashMap::new())
    }
}
